module.exports = {
  root: true,
  env: {
    browser: true,
    es6: true,
    node: true
  },
  ignorePatterns: ["node_modules/", "**/coverage/*", "**/dist/*", "**/types/*", "**/__mocks__/*", "**/*.vue", "**/*.d.ts", "**/*.js"],
  parser: "@typescript-eslint/parser",
  parserOptions: {
    project: "./tsconfig.json"
  },
  plugins: [
    "@typescript-eslint"
  ],
  extends: [
    "airbnb-typescript/base"
  ],
  rules: {
    // allow functions to be used before their definition
    '@typescript-eslint/no-use-before-define': ['error', { functions: false }],
    // allow circular import references,
    'import/no-cycle': 'off',
    // ignore error caused by monorepo and path aliasesdangle
    'import/no-unresolved': 'off',
    // ignore enforcement of consistent linebreak style
    'linebreak-style': 0,
    "no-console": process.env.NODE_ENV === "production" ? "warn" : "off",
    "no-debugger": process.env.NODE_ENV === "production" ? "warn" : "off",
    "import/prefer-default-export": "off",
    quotes: 0,
    indent: 0,
    'no-tabs': 0,
    '@typescript-eslint/comma-dangle': 0,
    '@typescript-eslint/no-unused-vars': 0,
    '@typescript-eslint/quotes': 0,
    '@typescript-eslint/object-curly-spacing': 0,
    'quote-props': 0,
    'no-restricted-globals': 0,
    '@typescript-eslint/lines-between-class-members': 0,
    'comma-dangle': 0,
    'prefer-template': 0,
    'prefer-destructuring': 0,
    'padded-blocks': 0,
    'prefer-arrow-callback': 0,
    'func-names': 0,
    '@typescript-eslint/indent': 0,
    'eslint operator-linebreak': 0,
    'no-param-reassign': 0,
    'class-methods-use-this': 0,
    "@typescript-eslint/no-explicit-any": 0,
    'max-len': 0,
    'no-underscore-dangle': 0,
    'object-curly-newline': 0,
    "import/extensions": [
      "error",
      "ignorePackages",
      {
        "js": "never",
        "jsx": "never",
        "ts": "never",
        "tsx": "never"
      }
    ],
    'no-useless-catch': 0
  }
}
